/* rec_get - read one record from record-binary file */
#include "rec_io.h"
bool rec_get(fd, buf, recno)
	rec_fd fd;		/* which file */
	data_ptr buf;	/* where to put the data */
	long recno;		/* {REC_NEXT,0:rec_nrecs(fd)-1} */
	{
	REC_FILE *rfp;
	short n;		/* size of each record */

	if (fd < 0 || fd >= REC_NFILE)	/* validate fd */
		return (NO);
	rfp = &rec_files[fd];
	n = rfp->_recsize;
	if (recno != REC_NEXT && recno < 0 || recno >= rfp->_nrecs)
		return (NO);
	else if (recno == REC_NEXT)
		;	/* no seek, ready for next record */
	else if (bin_lseek(fd, rfp->_byte0 + recno * n, SEEK_SET) < 0)
		return (NO);
	return (bin_read(fd, buf, n) == n);
	}
